
set cats {A B C D}; set nums {1 2 3 4 5}
proc def_vals {} { uplevel 1 { set yes 2; set any 0; set no -2 } }

set inconsistency {}

array set computed {-2 1   -1 0    0 0     1 0   2 1}
array set compval {-2 -2   -1 -2   0 0     1 2   2 2}

proc init_feld {} { global feld nrplus cats nums; def_vals
    foreach c $cats { foreach n $nums {
        foreach d $cats { foreach m $nums {
            if {$c < $d} { set_cell $c $n $d $m $any }
        }}
    }}
    foreach c $cats { foreach d $cats {
        if {$c < $d} { set nrplus([list $c $d]) 0 }
    }}
}

proc addplus {c d {D 1}} { global nrplus
    if {$c < $d} { incr nrplus([list $c $d]) $D
    } else { incr nrplus([list $d $c]) $D }
}

proc recalc_all_r {} { global feld computed 
    foreach f [array names feld] { set r [eval get_cell $f]
        if {$computed($r)} { 
            if {$r==2} {foreach {c x d y} $f {addplus $c $d -1}}
            eval set_cell $f 0
        }
    }
    foreach f [array names feld] { 
        set res [eval propagate $f]
        if {$res == -2} {return -code return -2}
    }
}
proc get_cell {A a B b} { global feld
    if {$A > $B} {return $feld([list $B $b $A $a])}
    return $feld([list $A $a $B $b])
}
proc set_cell {A a B b v} { global feld 
    if {$A > $B} {return [set_cell $B $b $A $a $v]}
    upvar "#0" feld([list $A $a $B $b]) f
    if {[info exists f]} {set o $f} {set o {}}
    set f $v 
    if {$o != $v} { cb_cell $A $a $B $b $v }
}

proc setcell {A a B b v} { global nums cats computed inconsistency; def_vals
    set r [get_cell $A $a $B $b]
    if {$inconsistency != {}} {
        # inconsistent ? then only "unsetting" is allowed, until it's ok.
        if {$v!=0 || $computed($r) || $r==0} {return -2}
        set inconsistency {}; # have a new try
    }
    if {$r==$v} {return 0}
    if {$r*$v>0} { # both +  or  both -
        if {$computed($v)} {return 0}
        set_cell $A $a $B $b $v; return 0
    }
    if {$r*$v<0} { # contradicting
        if {$computed($v)} {incons_r $A $a $B $b}
        if {!$computed($r)} {
            if {$r==1} { addplus $A $B -1 }    
            set_cell $A $a $B $b $any; recalc_all_r
        } 
        if {[get_cell $A $a $B $b]!=0} {return -1}
    }
    if {$v!=0} { global compval
        if {$compval($v)==$yes} { addplus $A $B }
        set_cell $A $a $B $b $v
        set res [propagate $A $a $B $b]
        if {$res == -2} {return -2}
    } else {
        if {!$computed($r)} {
            if {$r==1} { addplus $A $B -1 }    
            set_cell $A $a $B $b $any; recalc_all_r
        }
    }
    return 1
}

proc setcell_r {A a B b v} {
    set res [setcell $A $a $B $b $v]
    if {$res == -2} {return -code return -2}
    return $res
}
proc propagate {A a B b} { global nums cats compval; def_vals
    set r [get_cell $A $a $B $b]
    if {$r>0} {
        foreach n $nums {
            if {$n != $a} { setcell_r $A $n $B $b $no }
            if {$n != $b} { setcell_r $A $a $B $n $no }
        }
        foreach c $cats {
            if {$c==$A || $c==$B} continue
            foreach n $nums {
                set v1 $compval([get_cell $A $a $c $n])
                set v2 $compval([get_cell $c $n $B $b])
                if {$v1==$v2} continue
                if {$v1!=0 && $v2!=0} {incons_r $A $a $B $b}
                if {$v1!=0} { setcell_r $c $n $B $b $v1 }
                if {$v2!=0} { setcell_r $A $a $c $n $v2 }
            }
        }
    } elseif {$r<0} {
        set aj -1; set bj -1
        foreach n $nums {
            if {$n!=$a && $aj!=-2} {
                set v1 [get_cell $A $n $B $b]
                if {$v1==0} { if {$aj>=0} {set aj -2} else {set aj $n}
                } elseif {$v1>0} { set aj -2 }
            }
            if {$n!=$b && $bj!=-2} {
                set v1 [get_cell $A $a $B $n]
                if {$v1==0} { if {$bj>=0} {set bj -2} else {set bj $n}
                } elseif {$v1>0} { set bj -2 }
            }
        }
        if {$aj==-1 || $bj==-1} {incons_r $A $a $B $b}
        if {$aj>=0} { setcell_r $A $aj $B $b $yes }
        if {$bj>=0} { setcell_r $A $a $B $bj $yes }

        # new attempt: find & mirror big blocks.
        set aj {}; set bj {}
        foreach n $nums {
            if {$n!=$a && $aj!="-"} {
                set v1 [get_cell $A $n $B $b]
                if {$v1>0} { set aj "-" 
                } elseif {$v1<0} { lappend aj $n }
            }
            if {$n!=$b && $bj!="-"} {
                set v1 [get_cell $A $a $B $n]
                if {$v1>0} { set bj "-" 
                } elseif {$v1<0} { lappend bj $n }
            }
        }
        if {$aj!="-"} {
            # !!!
        }
        


        foreach c $cats { 
            if {$c==$A || $c==$B} continue
            foreach n $nums {
                if {[get_cell $c $n $B $b]>0} {
                    set v1 [get_cell $A $a $c $n]
                    if {$v1 > 0} {incons_r $A $a $B $b}
                    if {$v1==0} { setcell_r $A $a $c $n $no }
                }
                if {[get_cell $A $a $c $n]>0} {
                    set v1 [get_cell $c $n $B $b]
                    if {$v1 > 0} {incons_r $A $a $B $b}
                    if {$v1==0} { setcell_r $c $n $B $b $no }
                }
            }
        }
        foreach c $cats {
            if {$c==$A || $c==$B} continue
            foreach n $nums {
                if {[get_cell $A $a $c $n] == 0} { set x 1
                    foreach j $nums { 
                        set v1 [get_cell $A $a $B $j]
                        set v2 [get_cell $B $j $c $n]
                        if {$v1>0 || $v2>0 || ($v1==0 && $v2==0)} { 
                            set x 0; break 
                        }
                    }
                    if {$x} { setcell_r $A $a $c $n $no }
                }
                if {[get_cell $c $n $B $b] == 0} { set x 1
                    foreach j $nums { 
                        set v1 [get_cell $A $j $B $b]
                        set v2 [get_cell $c $n $A $j]
                        if {$v1>0 || $v2>0 || ($v1==0 && $v2==0)} { 
                            set x 0; break 
                        }
                    }
                    if {$x} { setcell_r $c $n $B $b $no }
                }
            }
        }
    } 
    return 0 
}


proc incons_r {A a B b} { global computed inconsistency
    set inconsistency [list $A $a $B $b]
    return -code return -2
}

proc cb_cell {A a B b v} {}
