
source tcllogik.tcl

array set dispval {-2 -    -1 =    0 \   1 #   2 + }
set raised {} 

set ncats [llength $cats]; incr ncats -1
for {set i 0} {$i < $ncats} {incr i} {
    for {set j $ncats} {$j > $i} {incr j -1} {
        set c [lindex $cats $i]; set d [lindex $cats $j]
        set f .,$c,$d
        frame $f -bd 1 -relief sunken  
        foreach n $nums { foreach m $nums {
            set l $f.$n,$m
            label $l -bd 1 -relief sunken -width 1 -padx 2 \
                -textvar display([list $c $n $d $m]) 
            set cells([list $c $n $d $m]) $l
            bindtags $l {cell all}
            grid $l -row $n -column  $m -sticky nsew
        }}
        grid $f -row $i -column [expr $ncats - $j] -sticky nsew
    }
}

proc win_setcell {w v} { 
    set nm [split [winfo name $w] ,]
    set cd [split [winfo name [winfo parent $w]] ,]
    foreach {n m} $nm {dummy c d} $cd  {break}

    global inconsistency raised cells
    if {$raised != {}} {
        $cells($raised) conf -relief sunken
        set raised {}
    }

    set res [ setcell $c $n $d $m $v ]
    if {$res < 0} {bell}

    if {$inconsistency != {}} {
        set raised $inconsistency
        $cells($raised) conf -relief raised
    }
}

proc cb_cell {A a B b v} { global dispval display latest 
    set display([list $A $a $B $b]) $dispval($v)
    if {$v != 0} { update idletasks; # after 50 }
}

init_feld

bind cell <1> {win_setcell %W 1}
bind cell <2> {win_setcell %W 0}
bind cell <Shift-1> {win_setcell %W 0}
bind cell <3> {win_setcell %W -1}
bind cell <Control-1> {win_setcell %W -1}

bind all <q> exit
bind all <r> init_feld
bind all <p> { parray nrplus; puts "" }

